# Contributing to iSpooge Live

iSpooge Live is a project aims to allow sovereigns to have a platform that plays 
well with others. This philosophy is reflected in our contributor guidelines. 
Thanks for considering helping us out.


## The lowdown

This project is a personal mission. I'm working toward a 1.0 release 
and have a development track that I want to lay down.

I want to share the project free, so it's MIT licensed. I may join
the social works later. I am happy for communities to develop without
my participation, am open to invitations.

## Important artifacts

* README.md -- developer documentation
* doc/ -- creator documentation
  * ROADMAP.md -- spoiler: we choose none
  * PERSONAS.md -- friends who think about iSpooge Live
  * THANKS.md -- contributors
  * operations.md --
  * features.md --
  * glossary.md -- 


## Communication

We assume an 8th grade level English proficiency. Translators welcome.

* https://www.flocabulary.com/8th-grade-vocabulary-word-list/
* https://www.flocabulary.com/wordlists/

### Philosophy

* Start with similarities.
* Show, don't tell--we prefer to communicate via repo activity RSS feeds.
* Focus on what's been done, connections--avoid speculation and wishing.
* Time is the enemy, ideas are cheap. (opportunity is where the value is).

eg. I see virtue 1,2,3 of that approach, but based on X,Y,Z I think this approach 
has merit; check out exhibits A and B.

### Making changes

* Please do not submit pull requests--we'll find your changes if we want them.
* Emails with a pointer to your repo and proposal to move forward are welcome (expect days of delay).
* You've already forked off, so we don't need to do anything if we disagree.

### Reporting bugs

We use the Eisenhower Matrix approach to classification:

* Important/Not - This is required for something that should work, eg. regressions
* Urgent/Not - This is required for something that needs to work NOW, eg. broken builds/blockers.

Please provide your best estimate for time and approach we should use to fix. Often
times this will lead to contributing a fix. Being "non-technical" is not reasonable.

## Recognition

* THANKS.md -- add your name when you fork, it'll make it in. I'll add you if we talk.

